#include "mainwindow.h"
#include "ui_mainwindow.h"

// ADS headers for TwinCAT 3
//#include "C:\TwinCAT\AdsApi\TcAdsDll\Include\TcAdsDef.h"
//#include "C:\TwinCAT\AdsApi\TcAdsDll\Include\TcAdsAPILONG.h"
//Linker: C:\TwinCAT\AdsApi\TcAdsDll\Lib\TcAdsDll.lib

#include "TcAdsDef.h"
#include "TcAdsAPILONG.h"

#include <QDebug>
#include "string.h"

#include <QLabel>





MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    labelNotification = new QLabel(this);

    //connect(this, SIGNAL(clicked()), this, SLOT(click()));

    CreateAdsNotification();


     connect(this, SIGNAL(&callback(AdsNotificationHeader*)), this->labelNotification, SLOT(UpdateUi(AdsNotificationHeader*)));
}

MainWindow::~MainWindow()
{
    delete ui;
    DeleteAdsNotification();

}


void MainWindow::CreateAdsNotification()
{
    // Connect to the Beckhoff controller



       nErr = AdsPortOpen();
       nErr = AdsGetLocalAddress(pAddr);

       if (nErr)
       {
           qDebug() << "Error connecting to Beckhoff controller: " << AdsGetLastError();
       }
       else
       {
           qDebug() << "Connected to Beckhoff controller";

           // Get the handle to the variable
           //const char* varName = "MAIN.nCounter"; // Replace with the name of your variable
           //uint32_t handle;

           // TwinCAT 3 RTS1 Port = 851
           pAddr->port = 851;

           // set the attributes of the notification
           adsNotificationAttrib.cbLength = 4;
           adsNotificationAttrib.nTransMode = ADSTRANS_SERVERONCHA;
           adsNotificationAttrib.nMaxDelay = 0;
           adsNotificationAttrib.nCycleTime = 10000000; // 1sec


           // get handle
           nErr = AdsSyncReadWriteReq(pAddr, ADSIGRP_SYM_HNDBYNAME, 0x0, sizeof(hUser), &hUser, sizeof(szVar), szVar);
           if (nErr)
               qDebug() <<  "Error: AdsSyncReadWriteReq: " << nErr << '\n';

           // initiate the transmission of the PLC-variable
           nErr = AdsSyncAddDeviceNotificationReq(pAddr, ADSIGRP_SYM_VALBYHND, hUser, &adsNotificationAttrib, Callback, hUser, &hNotification);
           if (nErr)
               qDebug() <<  "Error: AdsSyncAddDeviceNotificationReq: " << nErr << '\n';

           qDebug() <<  "Notification: " << hNotification << "\n\n";
           //cout.flush();

       }
}



void MainWindow::DeleteAdsNotification()
{
    // Close the connection to the Beckhoff controller
    // finish the transmission of the PLC-variable
    nErr = AdsSyncDelDeviceNotificationReq(pAddr, hNotification);
    if (nErr)
        qDebug() << "Error: AdsSyncDelDeviceNotificationReq: " << nErr << '\n';

    // release handle
    nErr = AdsSyncWriteReq(pAddr, ADSIGRP_SYM_RELEASEHND, 0, sizeof(hUser), &hUser);
    if (nErr)
        qDebug() << "Error: AdsSyncWriteReq: " << nErr << '\n';

    // Close the communication port
    nErr = AdsPortClose();
    if (nErr)
        qDebug() << "Error: AdsPortClose: " << nErr << '\n';
}

// Callback-function
void __stdcall MainWindow::Callback(AmsAddr* pAddr, AdsNotificationHeader* pNotification, ulong hUser)
{
 int         nIndex;
 static ulong     nCount = 0;


 qDebug() << ++nCount << ". Call:\n";

 // print (to screen)) the value of the variable
qDebug() << "Value: " << *(ulong *)pNotification->data << '\n';
qDebug() << "Notification: " << pNotification->hNotification << '\n';

emit UpdateUi(pNotification); // Signal senden

//labelNotification->setText("Test");


 // Größe des Buffers in Byte
 qDebug() << "SampleSize: " << pNotification->cbSampleSize << '\n';

 // 32-Bit Variable (auch Zeiger), die beim AddNotification gesetzt wurde // (siehe main)
qDebug() << "hUser: " << hUser << '\n';

 // Print out the ADS-address of the sender
qDebug()<< "ServerNetId: ";
 for (nIndex = 0; nIndex < 6; nIndex++)
 qDebug() << (int)pAddr->netId.b[nIndex] << ".";
 qDebug() << "\nPort: " << pAddr->port << "\n\n";
 //cout.flush();
}

void MainWindow::UpdateUi(AdsNotificationHeader* pNotification)
{
    qDebug() << "Aufgerufen";

    //labelNotification->setText(QString::number(*(ulong *)pNotification->data));
}



