#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QLabel>

// ADS headers for TwinCAT 3
//#include "C:\TwinCAT\AdsApi\TcAdsDll\Include\TcAdsDef.h"
//#include "C:\TwinCAT\AdsApi\TcAdsDll\Include\TcAdsAPILONG.h"
//Linker: C:\TwinCAT\AdsApi\TcAdsDll\Lib\TcAdsDll.lib

#include "TcAdsDef.h"
#include "TcAdsAPILONG.h"

#include "string.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();


    void CreateAdsNotification();
    void DeleteAdsNotification();
    QLabel* labelNotification;
    static void __stdcall Callback(AmsAddr* pAddr, AdsNotificationHeader* pNotification, ulong hUser);



private:
    Ui::MainWindow *ui;


    long         nErr, nPort;
    AmsAddr        Addr;
    PAmsAddr     pAddr = &Addr;
    ulong         hNotification, hUser;
    AdsNotificationAttrib adsNotificationAttrib;
    char                 szVar[14] = {"MAIN.nCounter"};

    static int nextId_;
    int id_;

public slots:
    static void UpdateUi(AdsNotificationHeader* pNotification); // click() überschreiben

signals:
    void clicked(int id); // ein neues Signal hinzufügen






};
#endif // MAINWINDOW_H
